Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcache.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcache.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearcache.php	(revision )
@@ -0,0 +1,43 @@
+<?php
+
+/**
+ * Smarty Method ClearCache
+ *
+ * Smarty::clearCache() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ClearCache
+{
+    /**
+     * Valid for Smarty object
+     *
+     * @var int
+     */
+    public $objMap = 1;
+
+    /**
+     * Empty cache for a specific template
+     *
+     * @api  Smarty::clearCache()
+     * @link http://www.smarty.net/docs/en/api.clear.cache.tpl
+     *
+     * @param \Smarty  $smarty
+     * @param  string  $template_name template name
+     * @param  string  $cache_id      cache id
+     * @param  string  $compile_id    compile id
+     * @param  integer $exp_time      expiration time
+     * @param  string  $type          resource type
+     *
+     * @return integer number of cache files deleted
+     */
+    public function clearCache(Smarty $smarty, $template_name, $cache_id = null, $compile_id = null, $exp_time = null, $type = null)
+    {
+        // load cache resource and call clear
+        $_cache_resource = Smarty_CacheResource::load($smarty, $type);
+        $_cache_resource->invalidLoadedCache($smarty);
+        return $_cache_resource->clear($smarty, $template_name, $cache_id, $compile_id, $exp_time);
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadfilter.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadfilter.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadfilter.php	(revision )
@@ -0,0 +1,77 @@
+<?php
+
+/**
+ * Smarty Method LoadFilter
+ *
+ * Smarty::loadFilter() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_LoadFilter
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Valid filter types
+     *
+     * @var array
+     */
+    private $filterTypes = array('pre' => true, 'post' => true, 'output' => true, 'variable' => true);
+
+    /**
+     * load a filter of specified type and name
+     *
+     * @api  Smarty::loadFilter()
+     *
+     * @link http://www.smarty.net/docs/en/api.load.filter.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type filter type
+     * @param  string                                                         $name filter name
+     *
+     * @return bool
+     * @throws SmartyException if filter could not be loaded
+     */
+    public function loadFilter(Smarty_Internal_TemplateBase $obj, $type, $name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        $this->_checkFilterType($type);
+        $_plugin = "smarty_{$type}filter_{$name}";
+        $_filter_name = $_plugin;
+        if (is_callable($_plugin)) {
+            $smarty->registered_filters[$type][$_filter_name] = $_plugin;
+            return true;
+        }
+        if ($smarty->loadPlugin($_plugin)) {
+            if (class_exists($_plugin, false)) {
+                $_plugin = array($_plugin, 'execute');
+            }
+            if (is_callable($_plugin)) {
+                $smarty->registered_filters[$type][$_filter_name] = $_plugin;
+                return true;
+            }
+        }
+        throw new SmartyException("{$type}filter \"{$name}\" not found or callable");
+    }
+
+    /**
+     * Check if filter type is valid
+     *
+     * @param string $type
+     *
+     * @throws \SmartyException
+     */
+    public function _checkFilterType($type)
+    {
+        if (!isset($this->filterTypes[$type])) {
+            throw new SmartyException("Illegal filter type \"{$type}\"");
+        }
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearassign.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearassign.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearassign.php	(revision )
@@ -0,0 +1,44 @@
+<?php
+
+/**
+ * Smarty Method ClearAssign
+ *
+ * Smarty::clearAssign() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ClearAssign
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * clear the given assigned template variable(s).
+     *
+     * @api  Smarty::clearAssign()
+     * @link http://www.smarty.net/docs/en/api.clear.assign.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string|array                                           $tpl_var the template variable(s) to clear
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
+     */
+    public function clearAssign(Smarty_Internal_Data $data, $tpl_var)
+    {
+        if (is_array($tpl_var)) {
+            foreach ($tpl_var as $curr_var) {
+                unset($data->tpl_vars[$curr_var]);
+            }
+        } else {
+            unset($data->tpl_vars[$tpl_var]);
+        }
+
+        return $data;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_rdelim.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_rdelim.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_rdelim.php	(revision )
@@ -25,11 +25,11 @@
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         $_attr = $this->getAttributes($compiler, $args);
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', null, true);
         }
         // this tag does not return compiled code
         $compiler->has_code = true;
Index: src/includes/classes/Smarty/sysplugins/smarty_resource_uncompiled.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_resource_uncompiled.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_resource_uncompiled.php	(revision )
@@ -17,6 +17,20 @@
 abstract class Smarty_Resource_Uncompiled extends Smarty_Resource
 {
     /**
+     * Flag that it's an uncompiled resource
+     *
+     * @var bool
+     */
+    public $uncompiled = true;
+
+    /**
+     * Resource does implement populateCompiledFilepath() method
+     *
+     * @var bool
+     */
+    public $hasCompiledHandler = true;
+
+    /**
      * Render and output the template (without using the compiler)
      *
      * @param  Smarty_Template_Source   $source    source object
@@ -37,5 +51,29 @@
         $compiled->filepath = false;
         $compiled->timestamp = false;
         $compiled->exists = false;
+    }
+
+    /**
+     * render compiled template code
+     *
+     * @param Smarty_Internal_Template $_template
+     *
+     * @return string
+     * @throws Exception
+     */
+    public function render($_template)
+    {
+        $level = ob_get_level();
+        ob_start();
+        try {
+            $this->renderUncompiled($_template->source, $_template);
+            return ob_get_clean();
+        }
+        catch (Exception $e) {
+            while (ob_get_level() > $level) {
+                ob_end_clean();
+            }
+            throw $e;
+        }
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_config_file_compiler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_config_file_compiler.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_config_file_compiler.php	(revision )
@@ -18,6 +18,20 @@
 class Smarty_Internal_Config_File_Compiler
 {
     /**
+     * Lexer class name
+     *
+     * @var string
+     */
+    public $lexer_class;
+
+    /**
+     * Parser class name
+     *
+     * @var string
+     */
+    public $parser_class;
+
+    /**
      * Lexer object
      *
      * @var object
@@ -41,9 +55,9 @@
     /**
      * Smarty object
      *
-     * @var Smarty_Internal_Config object
+     * @var Smarty_Internal_Template object
      */
-    public $config;
+    public $template;
 
     /**
      * Compiled config data sections and variables
@@ -53,39 +67,52 @@
     public $config_data = array();
 
     /**
+     * compiled config data must always be written
+     *
+     * @var bool
+     */
+    public $write_compiled_code = true;
+
+    /**
      * Initialize compiler
      *
-     * @param Smarty $smarty base instance
+     * @param string $lexer_class  class name
+     * @param string $parser_class class name
+     * @param Smarty $smarty       global instance
      */
-    public function __construct($smarty)
+    public function __construct($lexer_class, $parser_class, Smarty $smarty)
     {
         $this->smarty = $smarty;
+        // get required plugins
+        $this->lexer_class = $lexer_class;
+        $this->parser_class = $parser_class;
+        $this->smarty = $smarty;
         $this->config_data['sections'] = array();
         $this->config_data['vars'] = array();
     }
 
     /**
-     * Method to compile a Smarty template.
+     * Method to compile Smarty config source.
      *
-     * @param  Smarty_Internal_Config $config config object
+     * @param Smarty_Internal_Template $template
      *
-     * @return bool                   true if compiling succeeded, false if it failed
+     * @return bool true if compiling succeeded, false if it failed
      */
-    public function compileSource(Smarty_Internal_Config $config)
+    public function compileTemplate(Smarty_Internal_Template $template)
     {
-        /* here is where the compiling takes place. Smarty
-          tags in the templates are replaces with PHP code,
-          then written to compiled files. */
-        $this->config = $config;
-        // get config file source
-        $_content = $config->source->content . "\n";
-        // on empty template just return
-        if ($_content == '') {
-            return true;
+        $this->template = $template;
+        $this->template->compiled->file_dependency[$this->template->source->uid] = array($this->template->source->filepath,
+                                                                                             $this->template->source->getTimeStamp(),
+                                                                                             $this->template->source->type);
+        if ($this->smarty->debugging) {
+            $this->smarty->_debug->start_compile($this->template);
         }
         // init the lexer/parser to compile the config file
-        $lex = new Smarty_Internal_Configfilelexer($_content, $this);
-        $parser = new Smarty_Internal_Configfileparser($lex, $this);
+        /* @var Smarty_Internal_ConfigFileLexer $lex */
+        $lex = new $this->lexer_class(str_replace(array("\r\n", "\r"), "\n", $template->source->getContent()) .
+                                      "\n", $this);
+        /* @var Smarty_Internal_ConfigFileParser $parser */
+        $parser = new $this->parser_class($lex, $this);
 
         if (function_exists('mb_internal_encoding') && ((int) ini_get('mbstring.func_overload')) & 2) {
             $mbEncoding = mb_internal_encoding();
@@ -94,7 +121,6 @@
             $mbEncoding = null;
         }
 
-
         if ($this->smarty->_parserdebug) {
             $parser->PrintTrace();
         }
@@ -111,8 +137,17 @@
         if ($mbEncoding) {
             mb_internal_encoding($mbEncoding);
         }
+        if ($this->smarty->debugging) {
+            $this->smarty->_debug->end_compile($this->template);
+        }
+        // template header code
+        $template_header = "<?php /* Smarty version " . Smarty::SMARTY_VERSION . ", created on " .
+            strftime("%Y-%m-%d %H:%M:%S") . "\n";
+        $template_header .= "         compiled from \"" . $this->template->source->filepath . "\" */ ?>\n";
 
-        $config->compiled_config = '<?php $_config_vars = ' . var_export($this->config_data, true) . '; ?>';
+        $code = '<?php $_smarty_tpl->smarty->ext->configLoad->_loadConfigVars($_smarty_tpl, ' .
+            var_export($this->config_data, true) . '); ?>';
+        return $template_header . $this->template->smarty->ext->_codeFrame->create($this->template, $code);
     }
 
     /**
@@ -129,13 +164,13 @@
     {
         $this->lex = Smarty_Internal_Configfilelexer::instance();
         $this->parser = Smarty_Internal_Configfileparser::instance();
-        // get template source line which has error
+        // get config source line which has error
         $line = $this->lex->line;
         if (isset($args)) {
             // $line--;
         }
         $match = preg_split("/\n/", $this->lex->data);
-        $error_text = "Syntax error in config file '{$this->config->source->filepath}' on line {$line} '{$match[$line - 1]}' ";
+        $error_text = "Syntax error in config file '{$this->template->source->filepath}' on line {$line} '{$match[$line - 1]}' ";
         if (isset($args)) {
             // individual error message
             $error_text .= $args;
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_stream.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_stream.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_stream.php	(revision )
@@ -70,11 +70,11 @@
      *
      * @param Smarty   $smarty        Smarty instance
      * @param string   $resource_name resource_name to make unique
-     * @param  boolean $is_config     flag for config resource
+     * @param  boolean $isConfig      flag for config resource
      *
      * @return string unique resource name
      */
-    protected function buildUniqueResourceName(Smarty $smarty, $resource_name, $is_config = false)
+    public function buildUniqueResourceName(Smarty $smarty, $resource_name, $isConfig = false)
     {
         return get_class($this) . '#' . $resource_name;
     }
Index: src/includes/classes/Smarty/sysplugins/smarty_undefined_variable.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_undefined_variable.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_undefined_variable.php	(revision )
@@ -0,0 +1,37 @@
+<?php
+
+/**
+ * class for undefined variable object
+ * This class defines an object for undefined variable handling
+ *
+ * @package    Smarty
+ * @subpackage Template
+ */
+class Smarty_Undefined_Variable
+{
+    /**
+     * Returns FALSE for 'nocache' and NULL otherwise.
+     *
+     * @param  string $name
+     *
+     * @return bool
+     */
+    public function __get($name)
+    {
+        if ($name == 'nocache') {
+            return false;
+        } else {
+            return null;
+        }
+    }
+
+    /**
+     * Always returns an empty string.
+     *
+     * @return string
+     */
+    public function __toString()
+    {
+        return "";
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdefaultmodifiers.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdefaultmodifiers.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdefaultmodifiers.php	(revision )
@@ -0,0 +1,38 @@
+<?php
+
+/**
+ * Smarty Method SetDefaultModifiers
+ *
+ * Smarty::setDefaultModifiers() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_SetDefaultModifiers
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Set default modifiers
+     *
+     * @api Smarty::setDefaultModifiers()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  array|string                                                   $modifiers modifier or list of modifiers
+     *                                                                                   to set
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function setDefaultModifiers(Smarty_Internal_TemplateBase $obj, $modifiers)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        $smarty->default_modifiers = (array) $modifiers;
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_function_plugin.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_function_plugin.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_function_plugin.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array();
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -34,15 +35,15 @@
     /**
      * Compiles code for the execution of function plugin
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      * @param  array  $parameter array with compilation parameter
      * @param  string $tag       name of function plugin
-     * @param  string $function  PHP function name
+     * @param  string                               $function PHP function name
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter, $tag, $function)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase  $compiler, $parameter, $tag, $function)
     {
         // This tag does create output
         $compiler->has_output = true;
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerplugin.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerplugin.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerplugin.php	(revision )
@@ -0,0 +1,50 @@
+<?php
+
+/**
+ * Smarty Method RegisterPlugin
+ *
+ * Smarty::registerPlugin() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterPlugin
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers plugin to be used in templates
+     *
+     * @api  Smarty::registerPlugin()
+     * @link http://www.smarty.net/docs/en/api.register.plugin.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type       plugin type
+     * @param  string                                                         $name       name of template tag
+     * @param  callback                                                       $callback   PHP callback to register
+     * @param  bool                                                           $cacheable  if true (default) this
+     *                                                                                    function is cache able
+     * @param  mixed                                                          $cache_attr caching attributes if any
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException              when the plugin tag is invalid
+     */
+    public function registerPlugin(Smarty_Internal_TemplateBase $obj, $type, $name, $callback, $cacheable = true, $cache_attr = null)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (isset($smarty->registered_plugins[$type][$name])) {
+            throw new SmartyException("Plugin tag \"{$name}\" already registered");
+        } elseif (!is_callable($callback)) {
+            throw new SmartyException("Plugin \"{$name}\" not callable");
+        } else {
+            $smarty->registered_plugins[$type][$name] = array($callback, (bool) $cacheable, (array) $cache_attr);
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -1,17 +1,9 @@
 <?php
 
-/**
- * Smarty Internal Plugin Templateparser
- * This is the template parser.
- * It is generated from the internal.templateparser.y file
- *
- * @package    Smarty
- * @subpackage Compiler
- * @author     Uwe Tews
- */
 class TP_yyToken implements ArrayAccess
 {
     public $string = '';
+
     public $metadata = array();
 
     public function __construct($s, $m = array())
@@ -31,25 +23,24 @@
 
     public function __toString()
     {
-        return $this->_string;
+        return $this->string;
     }
 
     public function offsetExists($offset)
     {
-        return isset($this->metadata[$offset]);
+        return isset($this->metadata[ $offset ]);
     }
 
     public function offsetGet($offset)
     {
-        return $this->metadata[$offset];
+        return $this->metadata[ $offset ];
     }
 
     public function offsetSet($offset, $value)
     {
         if ($offset === null) {
-            if (isset($value[0])) {
+            if (isset($value[ 0 ])) {
-                $x = ($value instanceof TP_yyToken) ?
-                    $value->metadata : $value;
+                $x = ($value instanceof TP_yyToken) ? $value->metadata : $value;
                 $this->metadata = array_merge($this->metadata, $x);
 
                 return;
@@ -61,16 +52,16 @@
         }
         if ($value instanceof TP_yyToken) {
             if ($value->metadata) {
-                $this->metadata[$offset] = $value->metadata;
+                $this->metadata[ $offset ] = $value->metadata;
             }
         } elseif ($value) {
-            $this->metadata[$offset] = $value;
+            $this->metadata[ $offset ] = $value;
         }
     }
 
     public function offsetUnset($offset)
     {
-        unset($this->metadata[$offset]);
+        unset($this->metadata[ $offset ]);
     }
 }
 
